<?php

/**
 * Class ilFormATestQuestionSetPoolSetList
 *
 * Date: 06.11.13
 * Time: 14:56
 * @author Thomas Joußen <tjoussen@databay.de>
 */
class ilFormATestQuestionSetPoolSetList extends ilXTSFModelList
{

    /**
     * @return array
     */
    public function loadData()
    {
        $available_pools = array_keys(ilObjQuestionSetPool::getAvailableQuestionSetPools());

        if (is_array($available_pools) && count($available_pools) == 0) {
            return null;
        }

        $provider = new ilFormATestSetBrowserProvider();
        $data = $provider->loadData(array(
            "set_pools" => $available_pools,
            "form_a_test" => $this->form_a_test->getId()
        ));

        return $data;
    }

    /**
     * @param array $data
     *
     * @return array
     */
    public function createObjectsFromData($data)
    {
        return $data;
    }
}
